Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 128)
+++ lemon/Makefile.am	(revision 135)
@@ -23,4 +23,5 @@
         lemon/bin_heap.h \
         lemon/color.h \
+        lemon/counter.h \
         lemon/dfs.h \
         lemon/dijkstra.h \
@@ -30,4 +31,5 @@
 	lemon/graph_utils.h \
 	lemon/kruskal.h \
+	lemon/lgf_reader.h \
 	lemon/list_graph.h \
 	lemon/maps.h \
@@ -36,4 +38,5 @@
         lemon/random.h \
 	lemon/smart_graph.h \
+        lemon/time_measure.h \
         lemon/tolerance.h \
 	lemon/unionfind.h
Index: lemon/assert.h
===================================================================
--- lemon/assert.h	(revision 112)
+++ lemon/assert.h	(revision 118)
@@ -27,69 +27,4 @@
 
 namespace lemon {
-
-  /// @{
-
-  ///\e
-  class AssertionFailedError : public LogicError {
-  protected:
-    const char *_assertion;
-    const char *_file;
-    int _line;
-    const char *_function;
-    const char *_message;
-
-    mutable ExceptionMember<std::string> _message_holder;
-  public:
-    ///\e
-    AssertionFailedError(const char *file, int line, const char *function,
-			 const char *msg, const char *assertion = 0) :
-      _assertion(assertion), _file(file), _line(line), 
-      _function(function), _message(msg) {}
-
-    ///\e
-    const char* assertion() const { return _assertion; }
-    ///\e
-    const char* message() const { return _message; }
-    ///\e
-    const char* file() const { return _file; }
-    ///\e
-    const char* function() const { return _function; }
-    ///\e
-    int line() const { return _line; }
-
-
-    virtual const char* what() const throw() {
-      try {
-	std::ostringstream ostr;
-	ostr << _file << ":" << _line << ": ";
-	if (_function)
-	  ostr << _function << ": ";
-	ostr << _message;
-	if (_assertion)
-	   ostr << " (assertion '" << _assertion << "' failed)";
-	_message_holder.set(ostr.str());
-	return ostr.str().c_str();
-      }
-      catch(...) {}
-      if( _message_holder.valid() ) return _message_holder.get().c_str();
-      return "lemon::AssertionFailedError";
-    }
-    virtual ~AssertionFailedError() throw() {}
-  };
-
-
-  inline void assert_fail_log(const char *file, int line,
-			      const char *function,
-			      const std::exception& exception, 
-			      const char *assertion)
-  {
-    std::cerr << file << ":" << line << ": ";
-    if (function)
-      std::cerr << function << ": ";
-    std::cerr << exception.what();
-    if (assertion)
-      std::cerr << " (assertion '" << assertion << "' failed)";
-    std::cerr << std::endl;
-  }
 
   inline void assert_fail_log(const char *file, int line, const char *function,
@@ -105,19 +40,4 @@
   }
 
-  inline void assert_fail_log(const char *file, int line, const char *function, 
-			      const std::string& message, const char *assertion)
-  {
-    assert_fail_log(file, line, function, message.c_str(), assertion);
-  }
-
-  inline void assert_fail_abort(const char *file, int line, 
-				const char *function,
-				const std::exception& exception,
-				const char *assertion)
-  {
-    assert_fail_log(file, line, function, exception, assertion);
-    std::abort();
-  }
-
   inline void assert_fail_abort(const char *file, int line,
 				const char *function, const char* message,
@@ -128,73 +48,25 @@
   }
 
-  inline void assert_fail_abort(const char *file, int line, 
-				const char *function, 
-				const std::string& message,
-				const char *assertion)
-  {
-    assert_fail_log(file, line, function, message.c_str(), assertion);
-    std::abort();
+  namespace _assert_bits {
+    
+    
+    inline const char* cstringify(const std::string& str) {
+      return str.c_str();
+    }
+
+    inline const char* cstringify(const char* str) {
+      return str;
+    }    
   }
-
-  inline void assert_fail_error(const char *file, int line, 
-				  const char *function,
-				  const std::exception& exception,
-				  const char *assertion)
-  {
-    throw AssertionFailedError(file, line, function, 
-			       exception.what(), assertion);
-  }
-
-  inline void assert_fail_error(const char *file, int line,
-				  const char *function, const char *message,
-				  const char *assertion)
-  {
-    throw AssertionFailedError(file, line, function, message, assertion);
-  }
-
-  inline void assert_fail_error(const char *file, int line,
-				  const char *function, 
-				  const std::string& message,
-				  const char *assertion)
-  {
-    throw AssertionFailedError(file, line, function, message.c_str(), assertion);
-  }
-
-  template <typename Exception>
-  inline void assert_fail_exception(const char *, int, const char *,
-				    const Exception& exception,
-				    const char *, const std::exception* = 
-				    static_cast<const Exception*>(0))
-  {
-    throw exception;
-  }
-
-  inline void assert_fail_exception(const char *file, int line,
-				    const char *function, const char *message,
-				    const char *assertion)
-  {
-    throw AssertionFailedError(file, line, function, message, assertion);
-  }
-
-  inline void assert_fail_exception(const char *file, int line, 
-				    const char *function, 
-				    const std::string& message,
-				    const char *assertion)
-  {
-    throw AssertionFailedError(file, line, function, message.c_str(), assertion);
-  }
-
-/// @}
-
 }
+
 #endif // LEMON_ASSERT_H
 
 #undef LEMON_ASSERT
 #undef LEMON_FIXME
+#undef LEMON_DEBUG
 
 #if (defined(LEMON_ASSERT_LOG) ? 1 : 0) +		\
   (defined(LEMON_ASSERT_ABORT) ? 1 : 0) +		\
-  (defined(LEMON_ASSERT_ERROR) ? 1 : 0) +		\
-  (defined(LEMON_ASSERT_EXCEPTION) ? 1 : 0) +		\
   (defined(LEMON_ASSERT_CUSTOM) ? 1 : 0) > 1
 #error "LEMON assertion system is not set properly"
@@ -203,9 +75,8 @@
 #if ((defined(LEMON_ASSERT_LOG) ? 1 : 0) +		\
      (defined(LEMON_ASSERT_ABORT) ? 1 : 0) +		\
-     (defined(LEMON_ASSERT_ERROR) ? 1 : 0) +		\
-     (defined(LEMON_ASSERT_EXCEPTION) ? 1 : 0) +	\
      (defined(LEMON_ASSERT_CUSTOM) ? 1 : 0) == 1 ||	\
      defined(LEMON_ENABLE_ASSERTS)) &&			\
-  defined(LEMON_DISABLE_ASSERTS)
+  (defined(LEMON_DISABLE_ASSERTS) ||			\
+   defined(NDEBUG))
 #error "LEMON assertion system is not set properly"
 #endif
@@ -218,10 +89,4 @@
 #  undef LEMON_ASSERT_HANDLER
 #  define LEMON_ASSERT_HANDLER ::lemon::assert_fail_abort
-#elif defined LEMON_ASSERT_ERROR
-#  undef LEMON_ASSERT_HANDLER
-#  define LEMON_ASSERT_HANDLER ::lemon::assert_fail_error
-#elif defined LEMON_ASSERT_EXCEPTION
-#  undef LEMON_ASSERT_HANDLER
-#  define LEMON_ASSERT_HANDLER ::lemon::assert_fail_exception
 #elif defined LEMON_ASSERT_CUSTOM
 #  undef LEMON_ASSERT_HANDLER
@@ -230,11 +95,11 @@
 #  endif
 #  define LEMON_ASSERT_HANDLER LEMON_CUSTOM_ASSERT_HANDLER
-#elif defined LEMON_ENABLE_ASSERTS
-#  undef LEMON_ASSERT_HANDLER
+#elif defined LEMON_DISABLE_ASSERTS
+#  undef LEMON_ASSERT_HANDLER
+#elif defined NDEBUG
+#  undef LEMON_ASSERT_HANDLER
+#else
 #  define LEMON_ASSERT_HANDLER ::lemon::assert_fail_abort
-#else
-#  undef LEMON_ASSERT_HANDLER
-#endif
-
+#endif
 
 #ifndef LEMON_FUNCTION_NAME
@@ -248,22 +113,22 @@
 /// \brief Macro for assertion with customizable message
 ///
-/// Macro for assertion with customizable message.  
-/// \param exp An expression that must be convertible to \c bool.
-/// If it is \c false, then an assertion is raised. The concrete
-/// behaviour depends on the settings of the assertion system.
-/// \param msg A <tt>const char*</tt>, a <tt>const std::string&</tt> or
-/// a <tt>const std::exception&</tt> parameter, which can be used to
-/// provide information about the circumstances of the failed assertion.
-///
-/// The assertions are disabled in the default behaviour.
-/// You can enable them with the following code:
-/// \code
-/// #define LEMON_ENABLE_ASSERTS
+/// Macro for assertion with customizable message.  \param exp An
+/// expression that must be convertible to \c bool.  If it is \c
+/// false, then an assertion is raised. The concrete behaviour depends
+/// on the settings of the assertion system.  \param msg A <tt>const
+/// char*</tt> parameter, which can be used to provide information
+/// about the circumstances of the failed assertion.
+///
+/// The assertions are enabled in the default behaviour.
+/// You can disable them with the following code:
+/// \code
+/// #define LEMON_DISABLE_ASSERTS
 /// \endcode
 /// or with compilation parameters:
 /// \code
-/// g++ -DLEMON_ENABLE_ASSERTS
-/// make CXXFLAGS='-DLEMON_ENABLE_ASSERTS'
-/// \endcode
+/// g++ -DLEMON_DISABLE_ASSERTS
+/// make CXXFLAGS='-DLEMON_DISABLE_ASSERTS'
+/// \endcode
+/// The checking is also disabled when the standard macro \c NDEBUG is defined.
 /// 
 /// The LEMON assertion system has a wide range of customization
@@ -275,36 +140,20 @@
 /// - \c LEMON_ASSERT_LOG The failed assertion prints a short log
 ///   message to the standard error and continues the execution.
-/// - \c LEMON_ASSERT_ABORT This mode is similar to the
-///   \c LEMON_ASSERT_LOG, but it aborts the program. It is the default
-///   behaviour mode when the assertions are enabled with
-///   \c LEMON_ENABLE_ASSERTS.
-/// - \c LEMON_ASSERT_ERROR The assertion throws an
-///   \ref lemon::AssertionFailedError "AssertionFailedError".
-///   If the \c msg parameter is an exception, then the result of the
-///   \ref lemon::Exception::what() "what()" member function is passed
-///   as error message.
-/// - \c LEMON_ASSERT_EXCEPTION If the specified \c msg is an
-///   exception, then it raised directly (solving that the exception
-///   can not be thrown polymorphically), otherwise an \ref
-///   lemon::AssertionFailedError "AssertionFailedError" is thrown with
-///   the given parameters.
+/// - \c LEMON_ASSERT_ABORT This mode is similar to the \c
+///   LEMON_ASSERT_LOG, but it aborts the program. It is the default
+///   behaviour.
 /// - \c LEMON_ASSERT_CUSTOM The user can define own assertion handler
-///   functions. Three overloaded functions should be defined with the
-///   following parameter lists:
+///   function.
 ///   \code
 ///     void custom_assert_handler(const char* file, int line, const char* function,
 ///                                const char* message, const char* assertion);
-///     void custom_assert_handler(const char* file, int line, const char* function,
-///                                const std::string& message, const char* assertion);
-///     void custom_assert_handler(const char* file, int line, const char* function,
-///                                const std::exception& message, const char* assertion);
 ///   \endcode
-///   The name of the functions should be defined as the \c
+///   The name of the function should be defined as the \c
 ///   LEMON_CUSTOM_ASSERT_HANDLER macro name. 
 ///   \code
 ///     #define LEMON_CUSTOM_ASSERT_HANDLER custom_assert_handler
 ///   \endcode
-///   Whenever an assertion is occured, one of the custom assertion
-///   handlers is called with appropiate parameters.
+///   Whenever an assertion is occured, the custom assertion
+///   handler is called with appropiate parameters.
 ///
 /// The assertion mode can also be changed within one compilation unit.
@@ -316,6 +165,5 @@
     LEMON_ASSERT_HANDLER(__FILE__, __LINE__,				\
 			 LEMON_FUNCTION_NAME,				\
-			 msg, #exp), 0)))
-
+			 ::lemon::_assert_bits::cstringify(msg), #exp), 0)))
 
 /// \ingroup exceptions
@@ -328,7 +176,39 @@
 ///   LEMON_ASSERT(false, msg);
 /// \endcode
+///
+/// \see LEMON_ASSERT 
 #  define LEMON_FIXME(msg)						\
-       (LEMON_ASSERT_HANDLER(__FILE__, __LINE__, LEMON_FUNCTION_NAME,	\
-			     "FIXME: " msg, static_cast<const char*>(0)))
+  (LEMON_ASSERT_HANDLER(__FILE__, __LINE__, LEMON_FUNCTION_NAME,	\
+			::lemon::_assert_bits::cstringify(msg),		\
+			static_cast<const char*>(0)))
+
+/// \ingroup exceptions
+///
+/// \brief Macro for internal assertions
+///
+/// Macro for internal assertions, it is used in the library to check
+/// the consistency of results of algorithms, several pre- and
+/// postconditions and invariants. The checking is disabled by
+/// default, but it can be turned on with the macro \c
+/// LEMON_ENABLE_DEBUG.
+/// \code
+/// #define LEMON_ENABLE_DEBUG
+/// \endcode
+/// or with compilation parameters:
+/// \code
+/// g++ -DLEMON_ENABLE_DEBUG
+/// make CXXFLAGS='-DLEMON_ENABLE_DEBUG'
+/// \endcode
+///
+/// This macro works like the \c LEMON_ASSERT macro, therefore the
+/// current behaviour depends on the settings of \c LEMON_ASSERT
+/// macro.
+///
+/// \see LEMON_ASSERT 
+#  define LEMON_DEBUG(exp, msg)						\
+  (static_cast<void> (!!(exp) ? 0 : (					\
+    LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                            \
+			 LEMON_FUNCTION_NAME,				\
+			 ::lemon::_assert_bits::cstringify(msg), #exp), 0)))
 
 #else
@@ -337,16 +217,38 @@
 #    define LEMON_ASSERT(exp, msg)  (static_cast<void>(0))
 #    define LEMON_FIXME(msg) (static_cast<void>(0))
+#    define LEMON_DEBUG(exp, msg) (static_cast<void>(0))
 #  else
-#    define LEMON_ASSERT(exp, msg)                 \
-       (static_cast<void> (!!(exp) ? 0 : (         \
-         LEMON_ASSERT_HANDLER(__FILE__, __LINE__,  \
-                              LEMON_FUNCTION_NAME, \
-                              msg, #exp), 0)))
-#    define LEMON_FIXME(msg) \
+#    define LEMON_ASSERT(exp, msg)					\
+       (static_cast<void> (!!(exp) ? 0 : (				\
+        LEMON_ASSERT_HANDLER(__FILE__, __LINE__,                        \
+			     LEMON_FUNCTION_NAME,			\
+			     ::lemon::_assert_bits::cstringify(msg),	\
+			     #exp), 0)))
+#    define LEMON_FIXME(msg)						\
        (LEMON_ASSERT_HANDLER(__FILE__, __LINE__, LEMON_FUNCTION_NAME,	\
-			     "FIXME: " msg,  static_cast<const char*>(0)))
+			     ::lemon::_assert_bits::cstringify(msg),	\
+			     static_cast<const char*>(0)))
+
+#    if LEMON_ENABLE_DEBUG
+#      define LEMON_DEBUG(exp, msg)
+         (static_cast<void> (!!(exp) ? 0 : (         \
+           LEMON_ASSERT_HANDLER(__FILE__, __LINE__,  \
+                                LEMON_FUNCTION_NAME, \
+				::lemon::_assert_bits::cstringify(msg),	\
+				#exp), 0)))
+#    else
+#      define LEMON_DEBUG(exp, msg) (static_cast<void>(0))
+#    endif
 #  endif
 
 #endif
 
-
+#ifdef DOXYGEN
+
+
+#else
+
+
+#endif
+
+
Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 107)
+++ lemon/bits/graph_extender.h	(revision 125)
@@ -368,8 +368,8 @@
 
     Node oppositeNode(const Node &n, const Edge &e) const {
-      if( n == Parent::source(e))
-	return Parent::target(e);
-      else if( n == Parent::target(e))
-	return Parent::source(e);
+      if( n == Parent::u(e))
+	return Parent::v(e);
+      else if( n == Parent::v(e))
+	return Parent::u(e);
       else
 	return INVALID;
@@ -382,5 +382,5 @@
     using Parent::direct;
     Arc direct(const Edge &edge, const Node &node) const {
-      return Parent::direct(edge, Parent::source(edge) == node);
+      return Parent::direct(edge, Parent::u(edge) == node);
     }
 
@@ -587,5 +587,5 @@
     /// Returns the base node of the iterator
     Node baseNode(const IncEdgeIt &edge) const {
-      return edge._direction ? source(edge) : target(edge);
+      return edge._direction ? u(edge) : v(edge);
     }
     /// Running node of the iterator
@@ -593,5 +593,5 @@
     /// Returns the running node of the iterator
     Node runningNode(const IncEdgeIt &edge) const {
-      return edge._direction ? target(edge) : source(edge);
+      return edge._direction ? v(edge) : u(edge);
     }
 
Index: lemon/bits/utility.h
===================================================================
--- lemon/bits/utility.h	(revision 39)
+++ lemon/bits/utility.h	(revision 117)
@@ -22,5 +22,5 @@
 // Boost enable_if library
 
-// Copyright 2003 © The Trustees of Indiana University.
+// Copyright 2003 (c) The Trustees of Indiana University.
 
 // Use, modification, and distribution is subject to the Boost Software
@@ -28,5 +28,5 @@
 // http://www.boost.org/LICENSE_1_0.txt)
 
-//    Authors: Jaakko Järvi (jajarvi at osl.iu.edu)
+//    Authors: Jaakko Jarvi (jajarvi at osl.iu.edu)
 //             Jeremiah Willcock (jewillco at osl.iu.edu)
 //             Andrew Lumsdaine (lums at osl.iu.edu)
Index: lemon/concepts/digraph.h
===================================================================
--- lemon/concepts/digraph.h	(revision 107)
+++ lemon/concepts/digraph.h	(revision 125)
@@ -468,10 +468,10 @@
       };
 
-      template <typename RDigraph>
+      template <typename _Digraph>
       struct Constraints {
         void constraints() {
-          checkConcept<IterableDigraphComponent<>, Digraph>();
-	  checkConcept<IDableDigraphComponent<>, Digraph>();
-          checkConcept<MappableDigraphComponent<>, Digraph>();
+          checkConcept<IterableDigraphComponent<>, _Digraph>();
+	  checkConcept<IDableDigraphComponent<>, _Digraph>();
+          checkConcept<MappableDigraphComponent<>, _Digraph>();
         }
       };
Index: lemon/concepts/graph.h
===================================================================
--- lemon/concepts/graph.h	(revision 107)
+++ lemon/concepts/graph.h	(revision 125)
@@ -732,10 +732,10 @@
       }
 
-      template <typename Graph>
+      template <typename _Graph>
       struct Constraints {
 	void constraints() {
-	  checkConcept<IterableGraphComponent<>, Graph>();
-	  checkConcept<IDableGraphComponent<>, Graph>();
-	  checkConcept<MappableGraphComponent<>, Graph>();
+	  checkConcept<IterableGraphComponent<>, _Graph>();
+	  checkConcept<IDableGraphComponent<>, _Graph>();
+	  checkConcept<MappableGraphComponent<>, _Graph>();
 	}
       };
Index: lemon/counter.h
===================================================================
--- lemon/counter.h	(revision 121)
+++ lemon/counter.h	(revision 121)
@@ -0,0 +1,181 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_COUNTER_H
+#define LEMON_COUNTER_H
+
+#include <string>
+#include <iostream>
+
+///\ingroup timecount
+///\file
+///\brief Tools for counting steps and events
+
+namespace lemon 
+{
+
+  template<class P> class _NoSubCounter;
+
+  template<class P>
+  class _SubCounter 
+  {
+    P &_parent;
+    std::string _title;
+    std::ostream &_os;
+    int count;
+  public:
+
+    typedef _SubCounter<_SubCounter<P> > SubCounter;
+    typedef _NoSubCounter<_SubCounter<P> > NoSubCounter;
+
+    _SubCounter(P &parent)
+      : _parent(parent), _title(), _os(std::cerr), count(0) {}
+    _SubCounter(P &parent,std::string title,std::ostream &os=std::cerr)
+      : _parent(parent), _title(title), _os(os), count(0) {}
+    _SubCounter(P &parent,const char *title,std::ostream &os=std::cerr)
+      : _parent(parent), _title(title), _os(os), count(0) {}
+    ~_SubCounter() { 
+      _os << _title << count <<std::endl;
+      _parent+=count;
+    }
+    _SubCounter &operator++() { count++; return *this;}
+    int operator++(int) { return count++; }
+    _SubCounter &operator--() { count--; return *this;}
+    int operator--(int) { return count--; }
+    _SubCounter &operator+=(int c) { count+=c; return *this;}
+    _SubCounter &operator-=(int c) { count-=c; return *this;}
+    void reset(int c=0) {count=c;}
+    operator int() {return count;}
+  };
+
+  template<class P>
+  class _NoSubCounter 
+  {
+    P &_parent;
+  public:
+    typedef _NoSubCounter<_NoSubCounter<P> > SubCounter;
+    typedef _NoSubCounter<_NoSubCounter<P> > NoSubCounter;
+  
+    _NoSubCounter(P &parent) :_parent(parent) {}
+    _NoSubCounter(P &parent,std::string,std::ostream &) 
+      :_parent(parent) {}
+    _NoSubCounter(P &parent,std::string) 
+      :_parent(parent) {}
+    _NoSubCounter(P &parent,const char *,std::ostream &)
+      :_parent(parent) {}
+    _NoSubCounter(P &parent,const char *)
+      :_parent(parent) {}
+    ~_NoSubCounter() {}
+    _NoSubCounter &operator++() { ++_parent; return *this;}
+    int operator++(int) { _parent++; return 0;}
+    _NoSubCounter &operator--() { --_parent; return *this;}
+    int operator--(int) { _parent--; return 0;}
+    _NoSubCounter &operator+=(int c) { _parent+=c; return *this;}
+    _NoSubCounter &operator-=(int c) { _parent-=c; return *this;}
+    void reset(int) {}
+    void reset() {}
+    operator int() {return 0;}
+  };
+
+
+  /// \addtogroup timecount
+  /// @{
+
+  ///A counter class
+
+  ///This class makes it easier to count certain events. You can increment
+  ///or decrement the counter using operator++ and operator--.
+  ///A report is automatically printed on destruction.
+  ///\todo More doc
+  class Counter 
+  {
+    std::string _title;
+    std::ostream &_os;
+    int count;
+  public:
+    ///\e
+
+    ///\todo document please.
+    ///
+    typedef _SubCounter<Counter> SubCounter;
+    ///\e
+
+    ///\todo document please.
+    ///
+    typedef _NoSubCounter<Counter> NoSubCounter;
+
+    ///\e
+    Counter() : _title(), _os(std::cerr), count(0) {}
+    ///\e
+    Counter(std::string title,std::ostream &os=std::cerr) 
+      : _title(title), _os(os), count(0) {}
+    ///\e
+    Counter(const char *title,std::ostream &os=std::cerr)
+      : _title(title), _os(os), count(0) {}
+    ///Destructor. Prints the given title and the value of the counter.
+    ~Counter() {
+      _os << _title << count <<std::endl;
+    }
+    ///\e
+    Counter &operator++() { count++; return *this;}
+    ///\e
+    int operator++(int) { return count++;}
+    ///\e
+    Counter &operator--() { count--; return *this;}
+    ///\e
+    int operator--(int) { return count--;}
+    ///\e
+    Counter &operator+=(int c) { count+=c; return *this;}
+    ///\e
+    Counter &operator-=(int c) { count-=c; return *this;}
+    ///\e
+    void reset(int c=0) {count=c;}
+    ///\e
+    operator int() {return count;}
+  };
+
+  ///'Do nothing' version of \ref Counter
+
+  ///'Do nothing' version of \ref Counter.
+  ///\sa Counter
+  class NoCounter
+  {
+  public:
+    typedef _NoSubCounter<NoCounter> SubCounter;
+    typedef _NoSubCounter<NoCounter> NoSubCounter;
+
+    NoCounter() {}
+    NoCounter(std::string,std::ostream &) {}
+    NoCounter(const char *,std::ostream &) {}
+    NoCounter(std::string) {}
+    NoCounter(const char *) {}
+    NoCounter &operator++() { return *this; }
+    int operator++(int) { return 0; }
+    NoCounter &operator--() { return *this; }
+    int operator--(int) { return 0; }
+    NoCounter &operator+=(int) { return *this;}
+    NoCounter &operator-=(int) { return *this;}
+    void reset(int) {}
+    void reset() {}
+    operator int() {return 0;}
+  };
+
+  ///@}
+}
+
+#endif
Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 127)
+++ lemon/lgf_reader.h	(revision 127)
@@ -0,0 +1,914 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+///\ingroup lemon_io
+///\file
+///\brief Lemon Graph Format reader.
+
+
+#ifndef LEMON_LGF_READER_H
+#define LEMON_LGF_READER_H
+
+#include <iostream>
+#include <fstream>
+#include <sstream>
+
+#include <set>
+#include <map>
+
+#include <lemon/assert.h>
+#include <lemon/graph_utils.h>
+
+#include <lemon/lgf_writer.h>
+
+#include <lemon/concept_check.h>
+#include <lemon/concepts/maps.h>
+
+namespace lemon {
+
+  namespace _reader_bits {
+
+    template <typename Value>
+    struct DefaultConverter {
+      Value operator()(const std::string& str) {
+	std::istringstream is(str);
+	Value value;
+	is >> value;
+
+	char c;
+	if (is >> std::ws >> c) {
+	  throw DataFormatError("Remaining characters in token");
+	}
+	return value;
+      }
+    };
+
+    template <>
+    struct DefaultConverter<std::string> {
+      std::string operator()(const std::string& str) {
+	return str;
+      }
+    };
+
+    template <typename _Item>    
+    class MapStorageBase {
+    public:
+      typedef _Item Item;
+
+    public:
+      MapStorageBase() {}
+      virtual ~MapStorageBase() {}
+
+      virtual void set(const Item& item, const std::string& value) = 0;
+
+    };
+
+    template <typename _Item, typename _Map, 
+	      typename _Converter = DefaultConverter<typename _Map::Value> >
+    class MapStorage : public MapStorageBase<_Item> {
+    public:
+      typedef _Map Map;
+      typedef _Converter Converter;
+      typedef _Item Item;
+      
+    private:
+      Map& _map;
+      Converter _converter;
+
+    public:
+      MapStorage(Map& map, const Converter& converter = Converter()) 
+	: _map(map), _converter(converter) {}
+      virtual ~MapStorage() {}
+
+      virtual void set(const Item& item ,const std::string& value) {
+	_map.set(item, _converter(value));
+      }
+    };
+
+    class ValueStorageBase {
+    public:
+      ValueStorageBase() {}
+      virtual ~ValueStorageBase() {}
+
+      virtual void set(const std::string&) = 0;
+    };
+
+    template <typename _Value, typename _Converter = DefaultConverter<_Value> >
+    class ValueStorage : public ValueStorageBase {
+    public:
+      typedef _Value Value;
+      typedef _Converter Converter;
+
+    private:
+      Value& _value;
+      Converter _converter;
+
+    public:
+      ValueStorage(Value& value, const Converter& converter = Converter())
+ 	: _value(value), _converter(converter) {}
+
+      virtual void set(const std::string& value) {
+	_value = _converter(value);
+      }
+    };
+
+    template <typename Value>
+    struct MapLookUpConverter {
+      const std::map<std::string, Value>& _map;
+
+      MapLookUpConverter(const std::map<std::string, Value>& map)
+        : _map(map) {}
+
+      Value operator()(const std::string& str) {
+        typename std::map<std::string, Value>::const_iterator it =
+          _map.find(str);
+        if (it == _map.end()) {
+          std::ostringstream msg;
+          msg << "Item not found: " << str;
+          throw DataFormatError(msg.str().c_str());
+        }
+        return it->second;
+      }
+    };
+
+    bool isWhiteSpace(char c) {
+      return c == ' ' || c == '\t' || c == '\v' || 
+        c == '\n' || c == '\r' || c == '\f'; 
+    }
+    
+    bool isOct(char c) {
+      return '0' <= c && c <='7'; 
+    }
+    
+    int valueOct(char c) {
+      LEMON_ASSERT(isOct(c), "The character is not octal.");
+      return c - '0';
+    }
+
+    bool isHex(char c) {
+      return ('0' <= c && c <= '9') || 
+	('a' <= c && c <= 'z') || 
+	('A' <= c && c <= 'Z'); 
+    }
+    
+    int valueHex(char c) {
+      LEMON_ASSERT(isHex(c), "The character is not hexadecimal.");
+      if ('0' <= c && c <= '9') return c - '0';
+      if ('a' <= c && c <= 'z') return c - 'a' + 10;
+      return c - 'A' + 10;
+    }
+
+    bool isIdentifierFirstChar(char c) {
+      return ('a' <= c && c <= 'z') ||
+	('A' <= c && c <= 'Z') || c == '_';
+    }
+
+    bool isIdentifierChar(char c) {
+      return isIdentifierFirstChar(c) ||
+	('0' <= c && c <= '9');
+    }
+
+    char readEscape(std::istream& is) {
+      char c;
+      if (!is.get(c))
+	throw DataFormatError("Escape format error");
+
+      switch (c) {
+      case '\\':
+	return '\\';
+      case '\"':
+	return '\"';
+      case '\'':
+	return '\'';
+      case '\?':
+	return '\?';
+      case 'a':
+	return '\a';
+      case 'b':
+	return '\b';
+      case 'f':
+	return '\f';
+      case 'n':
+	return '\n';
+      case 'r':
+	return '\r';
+      case 't':
+	return '\t';
+      case 'v':
+	return '\v';
+      case 'x':
+	{
+	  int code;
+	  if (!is.get(c) || !isHex(c)) 
+	    throw DataFormatError("Escape format error");
+	  else if (code = valueHex(c), !is.get(c) || !isHex(c)) is.putback(c);
+	  else code = code * 16 + valueHex(c);
+	  return code;
+	}
+      default:
+	{
+	  int code;
+	  if (!isOct(c)) 
+	    throw DataFormatError("Escape format error");
+	  else if (code = valueOct(c), !is.get(c) || !isOct(c)) 
+	    is.putback(c);
+	  else if (code = code * 8 + valueOct(c), !is.get(c) || !isOct(c)) 
+	    is.putback(c);
+	  else code = code * 8 + valueOct(c);
+	  return code;
+	}	      
+      } 
+    }
+    
+    std::istream& readToken(std::istream& is, std::string& str) {
+      std::ostringstream os;
+
+      char c;
+      is >> std::ws;
+      
+      if (!is.get(c)) 
+	return is;
+
+      if (c == '\"') {
+	while (is.get(c) && c != '\"') {
+	  if (c == '\\') 
+	    c = readEscape(is);
+	  os << c;
+	}
+	if (!is) 
+	  throw DataFormatError("Quoted format error");
+      } else {
+	is.putback(c);
+	while (is.get(c) && !isWhiteSpace(c)) {
+	  if (c == '\\') 
+	    c = readEscape(is);
+	  os << c;
+	}
+	if (!is) {
+	  is.clear();
+	} else {
+	  is.putback(c);
+	}
+      }
+      str = os.str();
+      return is;
+    }
+
+    std::istream& readIdentifier(std::istream& is, std::string& str) {
+      std::ostringstream os;
+
+      char c;
+      is >> std::ws;
+      
+      if (!is.get(c))
+	return is;
+
+      if (!isIdentifierFirstChar(c))
+	throw DataFormatError("Wrong char in identifier");
+      
+      os << c;
+      
+      while (is.get(c) && !isWhiteSpace(c)) {
+	if (!isIdentifierChar(c)) 
+	  throw DataFormatError("Wrong char in identifier");	  
+	os << c;
+      }
+      if (!is) is.clear();
+     
+      str = os.str();
+      return is;
+    }
+    
+  }
+  
+  /// \e
+  template <typename _Digraph>
+  class DigraphReader {
+  public:
+
+    typedef _Digraph Digraph;
+    GRAPH_TYPEDEFS(typename Digraph);
+    
+  private:
+
+
+    std::istream* _is;
+    bool local_is;
+
+    Digraph& _digraph;
+
+    std::string _nodes_caption;
+    std::string _arcs_caption;
+    std::string _attributes_caption;
+
+    typedef std::map<std::string, Node> NodeIndex;
+    NodeIndex _node_index;
+    typedef std::map<std::string, Arc> ArcIndex;
+    ArcIndex _arc_index;
+    
+    typedef std::vector<std::pair<std::string, 
+      _reader_bits::MapStorageBase<Node>*> > NodeMaps;    
+    NodeMaps _node_maps; 
+
+    typedef std::vector<std::pair<std::string,
+      _reader_bits::MapStorageBase<Arc>*> >ArcMaps;
+    ArcMaps _arc_maps;
+
+    typedef std::multimap<std::string, _reader_bits::ValueStorageBase*> 
+      Attributes;
+    Attributes _attributes;
+
+    bool _use_nodes;
+    bool _use_arcs;
+
+    int line_num;
+    std::istringstream line;
+
+  public:
+
+    /// \e
+    DigraphReader(std::istream& is, Digraph& digraph) 
+      : _is(&is), local_is(false), _digraph(digraph),
+	_use_nodes(false), _use_arcs(false) {}
+
+    /// \e
+    DigraphReader(const std::string& fn, Digraph& digraph) 
+      : _is(new std::ifstream(fn.c_str())), local_is(true), _digraph(digraph),
+    	_use_nodes(false), _use_arcs(false) {}
+
+
+    /// \e
+    DigraphReader(const char* fn, Digraph& digraph) 
+      : _is(new std::ifstream(fn)), local_is(true), _digraph(digraph),
+    	_use_nodes(false), _use_arcs(false) {}
+
+    /// \e
+    DigraphReader(DigraphReader& other) 
+      : _is(other._is), local_is(other.local_is), _digraph(other._digraph),
+	_use_nodes(other._use_nodes), _use_arcs(other._use_arcs) {
+
+      other.is = 0;
+      other.local_is = false;
+      
+      _node_index.swap(other._node_index);
+      _arc_index.swap(other._arc_index);
+
+      _node_maps.swap(other._node_maps);
+      _arc_maps.swap(other._arc_maps);
+      _attributes.swap(other._attributes);
+
+      _nodes_caption = other._nodes_caption;
+      _arcs_caption = other._arcs_caption;
+      _attributes_caption = other._attributes_caption;
+    }
+
+    /// \e
+    ~DigraphReader() {
+      for (typename NodeMaps::iterator it = _node_maps.begin(); 
+	   it != _node_maps.end(); ++it) {
+	delete it->second;
+      }
+
+      for (typename ArcMaps::iterator it = _arc_maps.begin(); 
+	   it != _arc_maps.end(); ++it) {
+	delete it->second;
+      }
+
+      for (typename Attributes::iterator it = _attributes.begin(); 
+	   it != _attributes.end(); ++it) {
+	delete it->second;
+      }
+
+      if (local_is) {
+	delete _is;
+      }
+
+    }
+
+  private:
+    
+    DigraphReader& operator=(const DigraphReader&);
+
+  public:
+
+    /// \e
+    template <typename Map>
+    DigraphReader& nodeMap(const std::string& caption, Map& map) {
+      checkConcept<concepts::WriteMap<Node, typename Map::Value>, Map>();
+      _reader_bits::MapStorageBase<Node>* storage = 
+	new _reader_bits::MapStorage<Node, Map>(map);
+      _node_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Map, typename Converter>
+    DigraphReader& nodeMap(const std::string& caption, Map& map, 
+			   const Converter& converter = Converter()) {
+      checkConcept<concepts::WriteMap<Node, typename Map::Value>, Map>();
+      _reader_bits::MapStorageBase<Node>* storage = 
+	new _reader_bits::MapStorage<Node, Map, Converter>(map, converter);
+      _node_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Map>
+    DigraphReader& arcMap(const std::string& caption, Map& map) {
+      checkConcept<concepts::WriteMap<Arc, typename Map::Value>, Map>();
+      _reader_bits::MapStorageBase<Arc>* storage = 
+	new _reader_bits::MapStorage<Arc, Map>(map);
+      _arc_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Map, typename Converter>
+    DigraphReader& arcMap(const std::string& caption, Map& map, 
+			  const Converter& converter = Converter()) {
+      checkConcept<concepts::WriteMap<Arc, typename Map::Value>, Map>();
+      _reader_bits::MapStorageBase<Arc>* storage = 
+	new _reader_bits::MapStorage<Arc, Map, Converter>(map, converter);
+      _arc_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Value>
+    DigraphReader& attribute(const std::string& caption, Value& value) {
+      _reader_bits::ValueStorageBase* storage = 
+	new _reader_bits::ValueStorage<Value>(value);
+      _attributes.insert(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Value, typename Converter>
+    DigraphReader& attribute(const std::string& caption, Value& value, 
+			     const Converter& converter = Converter()) {
+      _reader_bits::ValueStorageBase* storage = 
+	new _reader_bits::ValueStorage<Value, Converter>(value, converter);
+      _attributes.insert(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    DigraphReader& node(const std::string& caption, Node& node) {
+      typedef _reader_bits::MapLookUpConverter<Node> Converter;
+      Converter converter(_node_index);
+      _reader_bits::ValueStorageBase* storage = 
+	new _reader_bits::ValueStorage<Node, Converter>(node, converter);
+      _attributes.insert(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    DigraphReader& arc(const std::string& caption, Arc& arc) {
+      typedef _reader_bits::MapLookUpConverter<Arc> Converter;
+      Converter converter(_arc_index);
+      _reader_bits::ValueStorageBase* storage = 
+	new _reader_bits::ValueStorage<Arc, Converter>(arc, converter);
+      _attributes.insert(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    DigraphReader& nodes(const std::string& caption) {
+      _nodes_caption = caption;
+      return *this;
+    }
+
+    /// \e
+    DigraphReader& arcs(const std::string& caption) {
+      _arcs_caption = caption;
+      return *this;
+    }
+
+    /// \e
+    DigraphReader& attributes(const std::string& caption) {
+      _attributes_caption = caption;
+      return *this;
+    }
+
+    /// \e
+    template <typename Map>
+    DigraphReader& useNodes(const Map& map) {
+      checkConcept<concepts::ReadMap<Node, typename Map::Value>, Map>();
+      LEMON_ASSERT(!_use_nodes, "Multiple usage of useNodes() member"); 
+      _use_nodes = true;
+      _writer_bits::DefaultConverter<typename Map::Value> converter;
+      for (NodeIt n(_digraph); n != INVALID; ++n) {
+	_node_index.insert(std::make_pair(converter(map[n]), n));
+      }
+      return *this;
+    }
+
+    /// \e
+    template <typename Map, typename Converter>
+    DigraphReader& useNodes(const Map& map, 
+			    const Converter& converter = Converter()) {
+      checkConcept<concepts::ReadMap<Node, typename Map::Value>, Map>();
+      LEMON_ASSERT(!_use_nodes, "Multiple usage of useNodes() member"); 
+      _use_nodes = true;
+      for (NodeIt n(_digraph); n != INVALID; ++n) {
+	_node_index.insert(std::make_pair(converter(map[n]), n));
+      }
+      return *this;
+    }
+
+    /// \e
+    template <typename Map>
+    DigraphReader& useArcs(const Map& map) {
+      checkConcept<concepts::ReadMap<Arc, typename Map::Value>, Map>();
+      LEMON_ASSERT(!_use_arcs, "Multiple usage of useArcs() member");
+      _use_arcs = true;
+      _writer_bits::DefaultConverter<typename Map::Value> converter;
+      for (ArcIt a(_digraph); a != INVALID; ++a) {
+	_arc_index.insert(std::make_pair(converter(map[a]), a));
+      }
+      return *this;
+    }
+
+    /// \e
+    template <typename Map, typename Converter>
+    DigraphReader& useArcs(const Map& map, 
+			    const Converter& converter = Converter()) {
+      checkConcept<concepts::ReadMap<Arc, typename Map::Value>, Map>();
+      LEMON_ASSERT(!_use_arcs, "Multiple usage of useArcs() member"); 
+      _use_arcs = true;
+      for (ArcIt a(_digraph); a != INVALID; ++a) {
+	_arc_index.insert(std::make_pair(converter(map[a]), a));
+      }
+      return *this;
+    }
+
+  private:
+
+    bool readLine() {
+      std::string str;
+      while(++line_num, std::getline(*_is, str)) {
+	line.clear(); line.str(str);
+	char c;
+	if (line >> std::ws >> c && c != '#') {
+	  line.putback(c);
+	  return true;
+	}
+      }
+      return false;
+    }
+
+    bool readSuccess() {
+      return static_cast<bool>(*_is);
+    }
+    
+    void skipSection() {
+      char c;
+      while (readSuccess() && line >> c && c != '@') {
+	readLine();
+      }
+      line.putback(c);
+    }
+
+    void readNodes() {
+
+      std::vector<int> map_index(_node_maps.size());
+      int map_num, label_index;
+
+      if (!readLine()) 
+	throw DataFormatError("Cannot find map captions");
+      
+      {
+	std::map<std::string, int> maps;
+	
+	std::string map;
+	int index = 0;
+	while (_reader_bits::readIdentifier(line, map)) {
+	  if (maps.find(map) != maps.end()) {
+	    std::ostringstream msg;
+	    msg << "Multiple occurence of node map: " << map;
+	    throw DataFormatError(msg.str().c_str());
+	  }
+	  maps.insert(std::make_pair(map, index));
+	  ++index;
+	}
+	
+	for (int i = 0; i < static_cast<int>(_node_maps.size()); ++i) {
+	  std::map<std::string, int>::iterator jt = 
+	    maps.find(_node_maps[i].first);
+	  if (jt == maps.end()) {
+	    std::ostringstream msg;
+	    msg << "Map not found in file: " << _node_maps[i].first;
+	    throw DataFormatError(msg.str().c_str());
+	  }
+	  map_index[i] = jt->second;
+	}
+
+	{
+	  std::map<std::string, int>::iterator jt = maps.find("label");
+	  if (jt == maps.end())
+	    throw DataFormatError("Label map not found in file");
+	  label_index = jt->second;
+	}
+	map_num = maps.size();
+      }
+
+      char c;
+      while (readLine() && line >> c && c != '@') {
+	line.putback(c);
+
+	std::vector<std::string> tokens(map_num);
+	for (int i = 0; i < map_num; ++i) {
+	  if (!_reader_bits::readToken(line, tokens[i])) {
+	    std::ostringstream msg;
+	    msg << "Column not found (" << i + 1 << ")";
+	    throw DataFormatError(msg.str().c_str());
+	  }
+	}
+	if (line >> std::ws >> c)
+	  throw DataFormatError("Extra character on the end of line");
+	
+	Node n;
+	if (!_use_nodes) {
+	  n = _digraph.addNode();
+	  _node_index.insert(std::make_pair(tokens[label_index], n));
+	} else {
+	  typename std::map<std::string, Node>::iterator it =
+	    _node_index.find(tokens[label_index]);
+	  if (it == _node_index.end()) {
+	    std::ostringstream msg;
+	    msg << "Node with label not found: " << tokens[label_index];
+	    throw DataFormatError(msg.str().c_str());	    
+	  }
+	  n = it->second;
+	}
+
+	for (int i = 0; i < static_cast<int>(_node_maps.size()); ++i) {
+	  _node_maps[i].second->set(n, tokens[map_index[i]]);
+	}
+
+      }
+      if (readSuccess()) {
+	line.putback(c);
+      }
+    }
+
+    void readArcs() {
+
+      std::vector<int> map_index(_arc_maps.size());
+      int map_num, label_index;
+
+      if (!readLine()) 
+	throw DataFormatError("Cannot find map captions");
+      
+      {
+	std::map<std::string, int> maps;
+	
+	std::string map;
+	int index = 0;
+	while (_reader_bits::readIdentifier(line, map)) {
+	  if (maps.find(map) != maps.end()) {
+	    std::ostringstream msg;
+	    msg << "Multiple occurence of arc map: " << map;
+	    throw DataFormatError(msg.str().c_str());
+	  }
+	  maps.insert(std::make_pair(map, index));
+	  ++index;
+	}
+	
+	for (int i = 0; i < static_cast<int>(_arc_maps.size()); ++i) {
+	  std::map<std::string, int>::iterator jt = 
+	    maps.find(_arc_maps[i].first);
+	  if (jt == maps.end()) {
+	    std::ostringstream msg;
+	    msg << "Map not found in file: " << _arc_maps[i].first;
+	    throw DataFormatError(msg.str().c_str());
+	  }
+	  map_index[i] = jt->second;
+	}
+
+	{
+	  std::map<std::string, int>::iterator jt = maps.find("label");
+	  if (jt == maps.end())
+	    throw DataFormatError("Label map not found in file");
+	  label_index = jt->second;
+	}
+	map_num = maps.size();
+      }
+
+      char c;
+      while (readLine() && line >> c && c != '@') {
+	line.putback(c);
+
+	std::string source_token;
+	std::string target_token;
+
+	if (!_reader_bits::readToken(line, source_token))
+	  throw DataFormatError("Source not found");
+
+	if (!_reader_bits::readToken(line, target_token))
+	  throw DataFormatError("Source not found");
+	
+	std::vector<std::string> tokens(map_num);
+	for (int i = 0; i < map_num; ++i) {
+	  if (!_reader_bits::readToken(line, tokens[i])) {
+	    std::ostringstream msg;
+	    msg << "Column not found (" << i + 1 << ")";
+	    throw DataFormatError(msg.str().c_str());
+	  }
+	}
+	if (line >> std::ws >> c)
+	  throw DataFormatError("Extra character on the end of line");
+	
+	Arc a;
+	if (!_use_arcs) {
+
+          typename NodeIndex::iterator it;
+ 
+          it = _node_index.find(source_token);
+          if (it == _node_index.end()) {
+            std::ostringstream msg;
+            msg << "Item not found: " << source_token;
+            throw DataFormatError(msg.str().c_str());
+          }
+          Node source = it->second;
+
+          it = _node_index.find(target_token);
+          if (it == _node_index.end()) {       
+            std::ostringstream msg;            
+            msg << "Item not found: " << target_token;
+            throw DataFormatError(msg.str().c_str());
+          }                                          
+          Node target = it->second;                            
+
+	  a = _digraph.addArc(source, target);
+	  _arc_index.insert(std::make_pair(tokens[label_index], a));
+	} else {
+	  typename std::map<std::string, Arc>::iterator it =
+	    _arc_index.find(tokens[label_index]);
+	  if (it == _arc_index.end()) {
+	    std::ostringstream msg;
+	    msg << "Arc with label not found: " << tokens[label_index];
+	    throw DataFormatError(msg.str().c_str());	    
+	  }
+	  a = it->second;
+	}
+
+	for (int i = 0; i < static_cast<int>(_arc_maps.size()); ++i) {
+	  _arc_maps[i].second->set(a, tokens[map_index[i]]);
+	}
+
+      }
+      if (readSuccess()) {
+	line.putback(c);
+      }
+    }
+
+    void readAttributes() {
+
+      std::set<std::string> read_attr;
+
+      char c;
+      while (readLine() && line >> c && c != '@') {
+	line.putback(c);
+	
+	std::string attr, token;
+	if (!_reader_bits::readIdentifier(line, attr))
+	  throw DataFormatError("Attribute name not found");
+	if (!_reader_bits::readToken(line, token))
+	  throw DataFormatError("Attribute value not found");
+	if (line >> c)
+	  throw DataFormatError("Extra character on the end of line");	  
+
+	{
+	  std::set<std::string>::iterator it = read_attr.find(attr);
+	  if (it != read_attr.end()) {
+	    std::ostringstream msg;
+	    msg << "Multiple occurence of attribute " << attr;
+	    throw DataFormatError(msg.str().c_str());
+	  }
+	  read_attr.insert(attr);
+	}
+	
+	{
+	  typename Attributes::iterator it = _attributes.lower_bound(attr);
+	  while (it != _attributes.end() && it->first == attr) {
+	    it->second->set(token);
+	    ++it;
+	  }
+	}
+
+      }
+      if (readSuccess()) {
+	line.putback(c);
+      }
+      for (typename Attributes::iterator it = _attributes.begin();
+	   it != _attributes.end(); ++it) {
+	if (read_attr.find(it->first) == read_attr.end()) {
+	  std::ostringstream msg;
+	  msg << "Attribute not found in file: " << it->first;
+	  throw DataFormatError(msg.str().c_str());
+	}	
+      }
+    }
+
+  public:
+    
+    /// \e
+    void run() {
+      
+      LEMON_ASSERT(_is != 0, "This reader assigned to an other reader");
+      
+      bool nodes_done = false;
+      bool arcs_done = false;
+      bool attributes_done = false;
+
+      line_num = 0;      
+      readLine();
+
+      while (readSuccess()) {
+	skipSection();
+	try {
+	  char c;
+	  std::string section, caption;
+	  line >> c;
+	  _reader_bits::readIdentifier(line, section);
+	  _reader_bits::readIdentifier(line, caption);
+
+	  if (line >> c) 
+	    throw DataFormatError("Extra character on the end of line");
+
+	  if (section == "nodes" && !nodes_done) {
+	    if (_nodes_caption.empty() || _nodes_caption == caption) {
+	      readNodes();
+	      nodes_done = true;
+	    }
+	  } else if ((section == "arcs" || section == "edges") && 
+		     !arcs_done) {
+	    if (_arcs_caption.empty() || _arcs_caption == caption) {
+	      readArcs();
+	      arcs_done = true;
+	    }
+	  } else if (section == "attributes" && !attributes_done) {
+	    if (_attributes_caption.empty() || _attributes_caption == caption) {
+	      readAttributes();
+	      attributes_done = true;
+	    }
+	  } else {
+	    readLine();
+	    skipSection();
+	  }
+	} catch (DataFormatError& error) {
+	  error.line(line_num);
+	  throw;
+	}	
+      }
+
+      if (!nodes_done) {
+	throw DataFormatError("Section @nodes not found");
+      }
+
+      if (!arcs_done) {
+	throw DataFormatError("Section @arcs not found");
+      }
+
+      if (!attributes_done && !_attributes.empty()) {
+	throw DataFormatError("Section @attributes not found");
+      }
+
+    }
+    
+  };
+
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(std::istream& is, Digraph& digraph) {
+    return DigraphReader<Digraph>(is, digraph);
+  }
+
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(const std::string& fn, 
+				       Digraph& digraph) {
+    return DigraphReader<Digraph>(fn, digraph);
+  }
+
+  template <typename Digraph>
+  DigraphReader<Digraph> digraphReader(const char* fn, Digraph& digraph) {
+    return DigraphReader<Digraph>(fn, digraph);
+  }
+}
+
+#endif
Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 127)
+++ lemon/lgf_writer.h	(revision 127)
@@ -0,0 +1,627 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+///\ingroup lemon_io
+///\file
+///\brief Lemon Graph Format writer.
+
+
+#ifndef LEMON_LGF_WRITER_H
+#define LEMON_LGF_WRITER_H
+
+#include <iostream>
+#include <fstream>
+#include <sstream>
+
+#include <algorithm>
+
+#include <vector>
+#include <functional>
+
+#include <lemon/assert.h>
+#include <lemon/graph_utils.h>
+
+namespace lemon {
+
+  namespace _writer_bits {
+
+    template <typename Value>
+    struct DefaultConverter {
+      std::string operator()(const Value& value) {
+	std::ostringstream os;
+	os << value;
+	return os.str();
+      }
+    };
+
+    template <typename T>
+    bool operator<(const T&, const T&) {
+      throw DataFormatError("Label map is not comparable");
+    }
+
+    template <typename _Map>
+    class MapLess {
+    public:
+      typedef _Map Map;
+      typedef typename Map::Key Item;
+
+    private:
+      const Map& _map;
+      
+    public:
+      MapLess(const Map& map) : _map(map) {}
+
+      bool operator()(const Item& left, const Item& right) {
+	return _map[left] < _map[right];
+      }
+    };
+
+    template <typename _Item>    
+    class MapStorageBase {
+    public:
+      typedef _Item Item;
+
+    public:
+      MapStorageBase() {}
+      virtual ~MapStorageBase() {}
+
+      virtual std::string get(const Item& item) = 0;
+      virtual void sort(std::vector<Item>&) = 0;
+    };
+
+    template <typename _Item, typename _Map, 
+	      typename _Converter = DefaultConverter<typename _Map::Value> >
+    class MapStorage : public MapStorageBase<_Item> {
+    public:
+      typedef _Map Map;
+      typedef _Converter Converter;
+      typedef _Item Item;
+      
+    private:
+      const Map& _map;
+      Converter _converter;
+
+    public:
+      MapStorage(const Map& map, const Converter& converter = Converter()) 
+	: _map(map), _converter(converter) {}
+      virtual ~MapStorage() {}
+
+      virtual std::string get(const Item& item) {
+	return _converter(_map[item]);
+      }
+      virtual void sort(std::vector<Item>& items) {
+	MapLess<Map> less(_map);
+	std::sort(items.begin(), items.end(), less);
+      }
+    };
+
+    class ValueStorageBase {
+    public:
+      ValueStorageBase() {}
+      virtual ~ValueStorageBase() {}
+
+      virtual std::string get() = 0;      
+    };
+
+    template <typename _Value, typename _Converter = DefaultConverter<_Value> >
+    class ValueStorage : public ValueStorageBase {
+    public:
+      typedef _Value Value;
+      typedef _Converter Converter;
+
+    private:
+      const Value& _value;
+      Converter _converter;
+
+    public:
+      ValueStorage(const Value& value, const Converter& converter = Converter())
+ 	: _value(value), _converter(converter) {}
+
+      virtual std::string get() {
+	return _converter(_value);
+      }
+    };
+
+    template <typename Value>
+    struct MapLookUpConverter {
+      const std::map<Value, std::string>& _map;
+      
+      MapLookUpConverter(const std::map<Value, std::string>& map) 
+	: _map(map) {}
+      
+      std::string operator()(const Value& str) {
+	typename std::map<Value, std::string>::const_iterator it = 
+	  _map.find(str);
+	if (it == _map.end()) {
+	  throw DataFormatError("Item not found");
+	}
+	return it->second;
+      }
+    };
+
+    bool isWhiteSpace(char c) {
+      return c == ' ' || c == '\t' || c == '\v' || 
+        c == '\n' || c == '\r' || c == '\f'; 
+    }
+
+    bool isEscaped(char c) {
+      return c == '\\' || c == '\"' || c == '\'' || 
+	c == '\a' || c == '\b';
+    }
+
+    static void writeEscape(std::ostream& os, char c) {
+      switch (c) {
+      case '\\':
+	os << "\\\\";
+	return;
+      case '\"':
+	os << "\\\"";
+	return;
+      case '\a':
+	os << "\\a";
+	return;
+      case '\b':
+	os << "\\b";
+	return;
+      case '\f':
+	os << "\\f";
+	return;
+      case '\r':
+	os << "\\r";
+	return;
+      case '\n':
+	os << "\\n";
+	return;
+      case '\t':
+	os << "\\t";
+	return;
+      case '\v':
+	os << "\\v";
+	return;
+      default:
+	if (c < 0x20) {
+	  os << '\\' << std::oct << static_cast<int>(c);
+	} else {
+	  os << c;
+	}
+	return;
+      }     
+    }
+
+    bool requireEscape(const std::string& str) {
+      std::istringstream is(str);
+      char c;
+      while (is.get(c)) {
+	if (isWhiteSpace(c) || isEscaped(c)) {
+	  return true;
+	}
+      }
+      return false;
+    }
+    
+    std::ostream& writeToken(std::ostream& os, const std::string& str) {
+
+      if (requireEscape(str)) {
+	os << '\"';
+	for (std::string::const_iterator it = str.begin(); 
+	     it != str.end(); ++it) {
+	  writeEscape(os, *it);
+	}	
+	os << '\"';
+      } else {
+	os << str;
+      }
+      return os;
+    }
+
+  }
+  
+  /// \e
+  template <typename _Digraph>
+  class DigraphWriter {
+  public:
+
+    typedef _Digraph Digraph;
+    GRAPH_TYPEDEFS(typename Digraph);
+    
+  private:
+
+
+    std::ostream* _os;
+    bool local_os;
+
+    Digraph& _digraph;
+
+    std::string _nodes_caption;
+    std::string _arcs_caption;
+    std::string _attributes_caption;
+    
+    typedef std::map<Node, std::string> NodeIndex;
+    NodeIndex _node_index;
+    typedef std::map<Arc, std::string> ArcIndex;
+    ArcIndex _arc_index;
+
+    typedef std::vector<std::pair<std::string, 
+      _writer_bits::MapStorageBase<Node>* > > NodeMaps;    
+    NodeMaps _node_maps; 
+
+    typedef std::vector<std::pair<std::string, 
+      _writer_bits::MapStorageBase<Arc>* > >ArcMaps;
+    ArcMaps _arc_maps;
+
+    typedef std::vector<std::pair<std::string, 
+      _writer_bits::ValueStorageBase*> > Attributes;
+    Attributes _attributes;
+
+    bool _skip_nodes;
+    bool _skip_arcs;
+
+  public:
+
+    /// \e
+    DigraphWriter(std::ostream& is, Digraph& digraph) 
+      : _os(&is), local_os(false), _digraph(digraph),
+	_skip_nodes(false), _skip_arcs(false) {}
+
+    /// \e
+    DigraphWriter(const std::string& fn, Digraph& digraph) 
+      : _os(new std::ofstream(fn.c_str())), local_os(true), _digraph(digraph),
+	_skip_nodes(false), _skip_arcs(false) {}
+
+    /// \e
+    DigraphWriter(const char* fn, Digraph& digraph) 
+      : _os(new std::ofstream(fn)), local_os(true), _digraph(digraph),
+	_skip_nodes(false), _skip_arcs(false) {}
+
+    DigraphWriter(DigraphWriter& other) 
+      : _os(other._os), local_os(other.local_os), _digraph(other._digraph),
+	_skip_nodes(other._skip_nodes), _skip_arcs(other._skip_arcs) {
+
+      other.is = 0;
+      other.local_os = false;
+
+      _node_index.swap(other._node_index);
+      _arc_index.swap(other._arc_index);
+
+      _node_maps.swap(other._node_maps);
+      _arc_maps.swap(other._arc_maps);
+      _attributes.swap(other._attributes);
+
+      _nodes_caption = other._nodes_caption;
+      _arcs_caption = other._arcs_caption;
+      _attributes_caption = other._attributes_caption;
+    }
+
+    /// \e
+    ~DigraphWriter() {
+      for (typename NodeMaps::iterator it = _node_maps.begin(); 
+	   it != _node_maps.end(); ++it) {
+	delete it->second;
+      }
+
+      for (typename ArcMaps::iterator it = _arc_maps.begin(); 
+	   it != _arc_maps.end(); ++it) {
+	delete it->second;
+      }
+
+      for (typename Attributes::iterator it = _attributes.begin(); 
+	   it != _attributes.end(); ++it) {
+	delete it->second;
+      }
+
+      if (local_os) {
+	delete _os;
+      }
+    }
+
+  private:
+    
+    DigraphWriter& operator=(const DigraphWriter&);
+
+  public:
+
+    /// \e
+    template <typename Map>
+    DigraphWriter& nodeMap(const std::string& caption, const Map& map) {
+      checkConcept<concepts::ReadMap<Node, typename Map::Value>, Map>();
+      _writer_bits::MapStorageBase<Node>* storage = 
+	new _writer_bits::MapStorage<Node, Map>(map);
+      _node_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Map, typename Converter>
+    DigraphWriter& nodeMap(const std::string& caption, const Map& map, 
+			   const Converter& converter = Converter()) {
+      checkConcept<concepts::ReadMap<Node, typename Map::Value>, Map>();
+      _writer_bits::MapStorageBase<Node>* storage = 
+	new _writer_bits::MapStorage<Node, Map, Converter>(map, converter);
+      _node_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Map>
+    DigraphWriter& arcMap(const std::string& caption, const Map& map) {
+      checkConcept<concepts::ReadMap<Arc, typename Map::Value>, Map>();
+      _writer_bits::MapStorageBase<Arc>* storage = 
+	new _writer_bits::MapStorage<Arc, Map>(map);
+      _arc_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Map, typename Converter>
+    DigraphWriter& arcMap(const std::string& caption, const Map& map, 
+			  const Converter& converter = Converter()) {
+      checkConcept<concepts::ReadMap<Arc, typename Map::Value>, Map>();
+      _writer_bits::MapStorageBase<Arc>* storage = 
+	new _writer_bits::MapStorage<Arc, Map, Converter>(map, converter);
+      _arc_maps.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Value>
+    DigraphWriter& attribute(const std::string& caption, const Value& value) {
+      _writer_bits::ValueStorageBase* storage = 
+	new _writer_bits::ValueStorage<Value>(value);
+      _attributes.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    template <typename Value, typename Converter>
+    DigraphWriter& attribute(const std::string& caption, const Value& value, 
+			     const Converter& converter = Converter()) {
+      _writer_bits::ValueStorageBase* storage = 
+	new _writer_bits::ValueStorage<Value, Converter>(value, converter);
+      _attributes.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    DigraphWriter& node(const std::string& caption, const Node& node) {
+      typedef _writer_bits::MapLookUpConverter<Node> Converter;
+      Converter converter(_node_index);
+      _writer_bits::ValueStorageBase* storage = 
+	new _writer_bits::ValueStorage<Node, Converter>(node, converter);
+      _attributes.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    DigraphWriter& arc(const std::string& caption, const Arc& arc) {
+      typedef _writer_bits::MapLookUpConverter<Arc> Converter;
+      Converter converter(_arc_index);
+      _writer_bits::ValueStorageBase* storage = 
+	new _writer_bits::ValueStorage<Arc, Converter>(arc, converter);
+      _attributes.push_back(std::make_pair(caption, storage));
+      return *this;
+    }
+
+    /// \e
+    DigraphWriter& nodes(const std::string& caption) {
+      _nodes_caption = caption;
+      return *this;
+    }
+
+    /// \e
+    DigraphWriter& arcs(const std::string& caption) {
+      _arcs_caption = caption;
+      return *this;
+    }
+
+    /// \e
+    DigraphWriter& attributes(const std::string& caption) {
+      _attributes_caption = caption;
+      return *this;
+    }
+
+    DigraphWriter& skipNodes() {
+      LEMON_ASSERT(!_skip_nodes, "Multiple usage of skipNodes() member");
+      return *this;
+    }
+
+    DigraphWriter& skipArcs() {
+      LEMON_ASSERT(!_skip_arcs, "Multiple usage of skipArcs() member");
+      return *this;
+    }
+
+  private:
+
+    void writeNodes() {
+      _writer_bits::MapStorageBase<Node>* label = 0;
+      for (typename NodeMaps::iterator it = _node_maps.begin();
+	   it != _node_maps.end(); ++it) {
+        if (it->first == "label") {
+	  label = it->second;
+	  break;
+	}
+      }
+
+      *_os << "@nodes";
+      if (!_nodes_caption.empty()) {
+	*_os << ' ' << _nodes_caption;
+      }
+      *_os << std::endl;
+
+      if (label == 0) {
+	*_os << "label" << '\t';
+      }
+      for (typename NodeMaps::iterator it = _node_maps.begin();
+	   it != _node_maps.end(); ++it) {
+	*_os << it->first << '\t';
+      }
+      *_os << std::endl;
+
+      std::vector<Node> nodes;
+      for (NodeIt n(_digraph); n != INVALID; ++n) {
+	nodes.push_back(n);
+      }
+      
+      if (label == 0) {
+	IdMap<Digraph, Node> id_map(_digraph);
+	_writer_bits::MapLess<IdMap<Digraph, Node> > id_less(id_map);
+	std::sort(nodes.begin(), nodes.end(), id_less);
+      } else {
+	label->sort(nodes);
+      }
+
+      for (int i = 0; i < static_cast<int>(nodes.size()); ++i) {
+	Node n = nodes[i];
+	if (label == 0) {
+	  std::ostringstream os;
+	  os << _digraph.id(n);
+	  _writer_bits::writeToken(*_os, os.str());
+	  *_os << '\t';
+	  _node_index.insert(std::make_pair(n, os.str()));
+	}
+	for (typename NodeMaps::iterator it = _node_maps.begin();
+	     it != _node_maps.end(); ++it) {
+	  std::string value = it->second->get(n);
+	  _writer_bits::writeToken(*_os, value);
+	  if (it->first == "label") {
+	    _node_index.insert(std::make_pair(n, value));
+	  }
+	  *_os << '\t';
+	}
+	*_os << std::endl;
+      }
+    }
+
+    void writeArcs() {
+      _writer_bits::MapStorageBase<Arc>* label = 0;
+      for (typename ArcMaps::iterator it = _arc_maps.begin();
+	   it != _arc_maps.end(); ++it) {
+        if (it->first == "label") {
+	  label = it->second;
+	  break;
+	}
+      }
+
+      *_os << "@arcs";
+      if (!_arcs_caption.empty()) {
+	*_os << ' ' << _arcs_caption;
+      }
+      *_os << std::endl;
+
+      *_os << '\t' << '\t';
+      if (label == 0) {
+	*_os << "label" << '\t';
+      }
+      for (typename ArcMaps::iterator it = _arc_maps.begin();
+	   it != _arc_maps.end(); ++it) {
+	*_os << it->first << '\t';
+      }
+      *_os << std::endl;
+
+      std::vector<Arc> arcs;
+      for (ArcIt n(_digraph); n != INVALID; ++n) {
+	arcs.push_back(n);
+      }
+      
+      if (label == 0) {
+	IdMap<Digraph, Arc> id_map(_digraph);
+	_writer_bits::MapLess<IdMap<Digraph, Arc> > id_less(id_map);
+	std::sort(arcs.begin(), arcs.end(), id_less);
+      } else {
+	label->sort(arcs);
+      }
+
+      for (int i = 0; i < static_cast<int>(arcs.size()); ++i) {
+	Arc a = arcs[i];
+	_writer_bits::writeToken(*_os, _node_index.
+				 find(_digraph.source(a))->second);
+	*_os << '\t';
+	_writer_bits::writeToken(*_os, _node_index.
+				 find(_digraph.target(a))->second);
+	*_os << '\t';
+	if (label == 0) {
+	  std::ostringstream os;
+	  os << _digraph.id(a);
+	  _writer_bits::writeToken(*_os, os.str());
+	  *_os << '\t';
+	  _arc_index.insert(std::make_pair(a, os.str()));
+	}
+	for (typename ArcMaps::iterator it = _arc_maps.begin();
+	     it != _arc_maps.end(); ++it) {
+	  std::string value = it->second->get(a);
+	  _writer_bits::writeToken(*_os, value);
+	  if (it->first == "label") {
+	    _arc_index.insert(std::make_pair(a, value));
+	  }
+	  *_os << '\t';
+	}
+	*_os << std::endl;
+      }
+    }
+
+    void writeAttributes() {
+      if (_attributes.empty()) return;
+      *_os << "@attributes";
+      if (!_attributes_caption.empty()) {
+	*_os << ' ' << _attributes_caption;
+      }
+      *_os << std::endl;
+      for (typename Attributes::iterator it = _attributes.begin();
+	   it != _attributes.end(); ++it) {
+	*_os << it->first << ' ';
+	_writer_bits::writeToken(*_os, it->second->get());
+	*_os << std::endl;
+      }
+    }
+    
+  public:
+    
+    /// \e
+    void run() {
+      if (!_skip_nodes) {
+	writeNodes();
+      }
+      if (!_skip_arcs) {      
+	writeArcs();
+      }
+      writeAttributes();
+    }
+
+    /// \e
+    std::ostream& stream() {
+      return *_os;
+    }
+  };
+
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(std::istream& is, Digraph& digraph) {
+    return DigraphWriter<Digraph>(is, digraph);
+  }
+
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const std::string& fn, 
+				       Digraph& digraph) {
+    return DigraphWriter<Digraph>(fn, digraph);
+  }
+
+  template <typename Digraph>
+  DigraphWriter<Digraph> digraphWriter(const char* fn, Digraph& digraph) {
+    return DigraphWriter<Digraph>(fn, digraph);
+  }
+}
+
+#endif
Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 104)
+++ lemon/maps.h	(revision 123)
@@ -117,5 +117,5 @@
 
     /// Constructor with specified initial value.
-    /// \param v is the initial value of the map.
+    /// \param v The initial value of the map.
     ConstMap(const Value &v) : _value(v) {}
 
@@ -142,4 +142,9 @@
   inline ConstMap<K, V> constMap(const V &v) {
     return ConstMap<K, V>(v);
+  }
+
+  template<typename K, typename V>
+  inline ConstMap<K, V> constMap() {
+    return ConstMap<K, V>();
   }
 
@@ -614,5 +619,5 @@
 	   typename V = typename F::result_type>
   class FunctorToMap : public MapBase<K, V> {
-    const F &_f;
+    F _f;
   public:
     typedef MapBase<K, V> Parent;
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 110)
+++ lemon/random.h	(revision 116)
@@ -796,5 +796,5 @@
 	  }
       } while(nu>std::pow(xi,delta-1.0)*std::exp(-xi));
-      return theta*(xi-gamma(int(std::floor(k))));
+      return theta*(xi+gamma(int(std::floor(k))));
     }
     
@@ -820,5 +820,5 @@
     double pareto(double k,double x_min)
     {
-      return exponential(gamma(k,1.0/x_min));
+      return exponential(gamma(k,1.0/x_min))+x_min;
     }  
       
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 109)
+++ lemon/smart_graph.h	(revision 125)
@@ -471,6 +471,6 @@
     Node target(Arc e) const { return Node(arcs[e._id].target); }
 
-    Node source(Edge e) const { return Node(arcs[2 * e._id].target); }
-    Node target(Edge e) const { return Node(arcs[2 * e._id + 1].target); }
+    Node u(Edge e) const { return Node(arcs[2 * e._id].target); }
+    Node v(Edge e) const { return Node(arcs[2 * e._id + 1].target); }
 
     static bool direction(Arc e) {
Index: lemon/time_measure.h
===================================================================
--- lemon/time_measure.h	(revision 126)
+++ lemon/time_measure.h	(revision 126)
@@ -0,0 +1,576 @@
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2008
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef LEMON_TIME_MEASURE_H
+#define LEMON_TIME_MEASURE_H
+
+///\ingroup timecount
+///\file
+///\brief Tools for measuring cpu usage
+
+#ifdef WIN32
+#include <windows.h>
+#include <cmath>
+#else
+#include <sys/times.h>
+#include <sys/time.h>
+#endif
+
+#include <fstream>
+#include <iostream>
+
+namespace lemon {
+
+  /// \addtogroup timecount
+  /// @{
+
+  /// A class to store (cpu)time instances.
+
+  /// This class stores five time values.
+  /// - a real time
+  /// - a user cpu time
+  /// - a system cpu time
+  /// - a user cpu time of children
+  /// - a system cpu time of children
+  ///
+  /// TimeStamp's can be added to or substracted from each other and
+  /// they can be pushed to a stream.
+  ///
+  /// In most cases, perhaps the \ref Timer or the \ref TimeReport
+  /// class is what you want to use instead.
+  ///
+  ///\author Alpar Juttner
+
+  class TimeStamp
+  {
+    double utime;
+    double stime;
+    double cutime;
+    double cstime;
+    double rtime;
+  
+    void _reset() { 
+      utime = stime = cutime = cstime = rtime = 0;
+    }
+
+  public:
+
+    ///Read the current time values of the process
+    void stamp()
+    {
+#ifndef WIN32
+      timeval tv;
+      gettimeofday(&tv, 0);
+      rtime=tv.tv_sec+double(tv.tv_usec)/1e6;
+
+      tms ts;
+      double tck=sysconf(_SC_CLK_TCK);
+      times(&ts);
+      utime=ts.tms_utime/tck;
+      stime=ts.tms_stime/tck;
+      cutime=ts.tms_cutime/tck;
+      cstime=ts.tms_cstime/tck;
+#else
+      static const double ch = 4294967296.0e-7;
+      static const double cl = 1.0e-7;
+
+      FILETIME system;
+      GetSystemTimeAsFileTime(&system);
+      rtime = ch * system.dwHighDateTime + cl * system.dwLowDateTime;
+
+      FILETIME create, exit, kernel, user;
+      if (GetProcessTimes(GetCurrentProcess(),&create, &exit, &kernel, &user)) {
+	utime = ch * user.dwHighDateTime + cl * user.dwLowDateTime;
+	stime = ch * kernel.dwHighDateTime + cl * kernel.dwLowDateTime;
+	cutime = 0;
+	cstime = 0;
+      } else {
+	rtime = 0;
+	utime = 0;
+	stime = 0;
+	cutime = 0;
+	cstime = 0;
+      }
+#endif      
+    }
+  
+    /// Constructor initializing with zero
+    TimeStamp()
+    { _reset(); }
+    ///Constructor initializing with the current time values of the process
+    TimeStamp(void *) { stamp();}
+  
+    ///Set every time value to zero
+    TimeStamp &reset() {_reset();return *this;}
+
+    ///\e
+    TimeStamp &operator+=(const TimeStamp &b)
+    {
+      utime+=b.utime;
+      stime+=b.stime;
+      cutime+=b.cutime;
+      cstime+=b.cstime;
+      rtime+=b.rtime;
+      return *this;
+    }
+    ///\e
+    TimeStamp operator+(const TimeStamp &b) const
+    {
+      TimeStamp t(*this);
+      return t+=b;
+    }
+    ///\e
+    TimeStamp &operator-=(const TimeStamp &b)
+    {
+      utime-=b.utime;
+      stime-=b.stime;
+      cutime-=b.cutime;
+      cstime-=b.cstime;
+      rtime-=b.rtime;
+      return *this;
+    }
+    ///\e
+    TimeStamp operator-(const TimeStamp &b) const
+    {
+      TimeStamp t(*this);
+      return t-=b;
+    }
+    ///\e
+    TimeStamp &operator*=(double b)
+    {
+      utime*=b;
+      stime*=b;
+      cutime*=b;
+      cstime*=b;
+      rtime*=b;
+      return *this;
+    }
+    ///\e
+    TimeStamp operator*(double b) const
+    {
+      TimeStamp t(*this);
+      return t*=b;
+    }
+    friend TimeStamp operator*(double b,const TimeStamp &t);
+    ///\e
+    TimeStamp &operator/=(double b)
+    {
+      utime/=b;
+      stime/=b;
+      cutime/=b;
+      cstime/=b;
+      rtime/=b;
+      return *this;
+    }
+    ///\e
+    TimeStamp operator/(double b) const
+    {
+      TimeStamp t(*this);
+      return t/=b;
+    }
+    ///The time ellapsed since the last call of stamp()
+    TimeStamp ellapsed() const
+    {
+      TimeStamp t(NULL);
+      return t-*this;
+    }
+  
+    friend std::ostream& operator<<(std::ostream& os,const TimeStamp &t);
+  
+    ///Gives back the user time of the process
+    double userTime() const
+    {
+      return utime;
+    }
+    ///Gives back the system time of the process
+    double systemTime() const
+    {
+      return stime;
+    }
+    ///Gives back the user time of the process' children
+
+    ///\note On <tt>WIN32</tt> platform this value is not calculated. 
+    ///
+    double cUserTime() const
+    {
+      return cutime;
+    }
+    ///Gives back the user time of the process' children
+
+    ///\note On <tt>WIN32</tt> platform this value is not calculated. 
+    ///
+    double cSystemTime() const
+    {
+      return cstime;
+    }
+    ///Gives back the real time
+    double realTime() const {return rtime;}
+  };
+
+  TimeStamp operator*(double b,const TimeStamp &t) 
+  {
+    return t*b;
+  }
+  
+  ///Prints the time counters
+
+  ///Prints the time counters in the following form:
+  ///
+  /// <tt>u: XX.XXs s: XX.XXs cu: XX.XXs cs: XX.XXs real: XX.XXs</tt>
+  ///
+  /// where the values are the
+  /// \li \c u: user cpu time,
+  /// \li \c s: system cpu time,
+  /// \li \c cu: user cpu time of children,
+  /// \li \c cs: system cpu time of children,
+  /// \li \c real: real time.
+  /// \relates TimeStamp
+  /// \note On <tt>WIN32</tt> platform the cummulative values are not
+  /// calculated.
+  inline std::ostream& operator<<(std::ostream& os,const TimeStamp &t)
+  {
+    os << "u: " << t.userTime() <<
+      "s, s: " << t.systemTime() <<
+      "s, cu: " << t.cUserTime() <<
+      "s, cs: " << t.cSystemTime() <<
+      "s, real: " << t.realTime() << "s";
+    return os;
+  }
+
+  ///Class for measuring the cpu time and real time usage of the process
+
+  ///Class for measuring the cpu time and real time usage of the process.
+  ///It is quite easy-to-use, here is a short example.
+  ///\code
+  /// #include<lemon/time_measure.h>
+  /// #include<iostream>
+  ///
+  /// int main()
+  /// {
+  ///
+  ///   ...
+  ///
+  ///   Timer t;
+  ///   doSomething();
+  ///   std::cout << t << '\n';
+  ///   t.restart();
+  ///   doSomethingElse();
+  ///   std::cout << t << '\n';
+  ///
+  ///   ...
+  ///
+  /// }
+  ///\endcode
+  ///
+  ///The \ref Timer can also be \ref stop() "stopped" and
+  ///\ref start() "started" again, so it is possible to compute collected
+  ///running times.
+  ///
+  ///\warning Depending on the operation system and its actual configuration
+  ///the time counters have a certain (10ms on a typical Linux system)
+  ///granularity.
+  ///Therefore this tool is not appropriate to measure very short times.
+  ///Also, if you start and stop the timer very frequently, it could lead to
+  ///distorted results.
+  ///
+  ///\note If you want to measure the running time of the execution of a certain
+  ///function, consider the usage of \ref TimeReport instead.
+  ///
+  ///\todo This shouldn't be Unix (Linux) specific.
+  ///\sa TimeReport
+  ///
+  ///\author Alpar Juttner
+  class Timer
+  {
+    int _running; //Timer is running iff _running>0; (_running>=0 always holds)
+    TimeStamp start_time; //This is the relativ start-time if the timer
+                          //is _running, the collected _running time otherwise.
+    
+    void _reset() {if(_running) start_time.stamp(); else start_time.reset();}
+  
+  public: 
+    ///Constructor.
+
+    ///\param run indicates whether or not the timer starts immediately.
+    ///
+    Timer(bool run=true) :_running(run) {_reset();}
+
+    ///\name Control the state of the timer
+    ///Basically a Timer can be either running or stopped,
+    ///but it provides a bit finer control on the execution.
+    ///The \ref Timer also counts the number of \ref start()
+    ///executions, and is stops only after the same amount (or more)
+    ///\ref stop() "stop()"s. This can be useful e.g. to compute the running time
+    ///of recursive functions.
+    ///
+
+    ///@{
+
+    ///Reset and stop the time counters
+
+    ///This function resets and stops the time counters
+    ///\sa restart()
+    void reset()
+    {
+      _running=0;
+      _reset();
+    }
+
+    ///Start the time counters
+    
+    ///This function starts the time counters.
+    ///
+    ///If the timer is started more than ones, it will remain running
+    ///until the same amount of \ref stop() is called.
+    ///\sa stop()
+    void start() 
+    {
+      if(_running) _running++;
+      else {
+	_running=1;
+	TimeStamp t;
+	t.stamp();
+	start_time=t-start_time;
+      }
+    }
+
+    
+    ///Stop the time counters
+
+    ///This function stops the time counters. If start() was executed more than
+    ///once, then the same number of stop() execution is necessary the really
+    ///stop the timer.
+    /// 
+    ///\sa halt()
+    ///\sa start()
+    ///\sa restart()
+    ///\sa reset()
+
+    void stop() 
+    {
+      if(_running && !--_running) {
+	TimeStamp t;
+	t.stamp();
+	start_time=t-start_time;
+      }
+    }
+
+    ///Halt (i.e stop immediately) the time counters
+
+    ///This function stops immediately the time counters, i.e. <tt>t.halt()</tt>
+    ///is a faster
+    ///equivalent of the following.
+    ///\code
+    ///  while(t.running()) t.stop()
+    ///\endcode
+    ///
+    ///
+    ///\sa stop()
+    ///\sa restart()
+    ///\sa reset()
+
+    void halt() 
+    {
+      if(_running) {
+	_running=0;
+	TimeStamp t;
+	t.stamp();
+	start_time=t-start_time;
+      }
+    }
+
+    ///Returns the running state of the timer
+
+    ///This function returns the number of stop() exections that is
+    ///necessary to really stop the timer.
+    ///For example the timer
+    ///is running if and only if the return value is \c true
+    ///(i.e. greater than
+    ///zero).
+    int running()  { return _running; }
+    
+    
+    ///Restart the time counters
+
+    ///This function is a shorthand for
+    ///a reset() and a start() calls.
+    ///
+    void restart() 
+    {
+      reset();
+      start();
+    }
+    
+    ///@}
+
+    ///\name Query Functions for the ellapsed time
+
+    ///@{
+
+    ///Gives back the ellapsed user time of the process
+    double userTime() const
+    {
+      return operator TimeStamp().userTime();
+    }
+    ///Gives back the ellapsed system time of the process
+    double systemTime() const
+    {
+      return operator TimeStamp().systemTime();
+    }
+    ///Gives back the ellapsed user time of the process' children
+
+    ///\note On <tt>WIN32</tt> platform this value is not calculated. 
+    ///
+    double cUserTime() const
+    {
+      return operator TimeStamp().cUserTime();
+    }
+    ///Gives back the ellapsed user time of the process' children
+
+    ///\note On <tt>WIN32</tt> platform this value is not calculated. 
+    ///
+    double cSystemTime() const
+    {
+      return operator TimeStamp().cSystemTime();
+    }
+    ///Gives back the ellapsed real time
+    double realTime() const
+    {
+      return operator TimeStamp().realTime();
+    }
+    ///Computes the ellapsed time
+
+    ///This conversion computes the ellapsed time, therefore you can print
+    ///the ellapsed time like this.
+    ///\code
+    ///  Timer t;
+    ///  doSomething();
+    ///  std::cout << t << '\n';
+    ///\endcode
+    operator TimeStamp () const
+    {
+      TimeStamp t;
+      t.stamp();
+      return _running?t-start_time:start_time;
+    }
+
+
+    ///@}
+  };
+
+  ///Same as \ref Timer but prints a report on destruction.
+
+  ///Same as \ref Timer but prints a report on destruction.
+  ///This example shows its usage.
+  ///\code
+  ///  void myAlg(ListGraph &g,int n)
+  ///  {
+  ///    TimeReport tr("Running time of myAlg: ");
+  ///    ... //Here comes the algorithm
+  ///  }
+  ///\endcode
+  ///
+  ///\sa Timer
+  ///\sa NoTimeReport
+  ///\todo There is no test case for this
+  class TimeReport : public Timer 
+  {
+    std::string _title;
+    std::ostream &_os;
+  public:
+    ///\e
+
+    ///\param title This text will be printed before the ellapsed time.
+    ///\param os The stream to print the report to.
+    ///\param run Sets whether the timer should start immediately.
+
+    TimeReport(std::string title,std::ostream &os=std::cerr,bool run=true) 
+      : Timer(run), _title(title), _os(os){}
+    ///\e Prints the ellapsed time on destruction.
+    ~TimeReport() 
+    {
+      _os << _title << *this << std::endl;
+    }
+  };
+      
+  ///'Do nothing' version of \ref TimeReport
+
+  ///\sa TimeReport
+  ///
+  class NoTimeReport
+  {
+  public:
+    ///\e
+    NoTimeReport(std::string,std::ostream &,bool) {}
+    ///\e
+    NoTimeReport(std::string,std::ostream &) {}
+    ///\e
+    NoTimeReport(std::string) {}
+    ///\e Do nothing.
+    ~NoTimeReport() {}
+
+    operator TimeStamp () const { return TimeStamp(); }
+    void reset() {}
+    void start() {}
+    void stop() {}
+    void halt() {} 
+    int running() { return 0; }
+    void restart() {}
+    double userTime() const { return 0; }
+    double systemTime() const { return 0; }
+    double cUserTime() const { return 0; }
+    double cSystemTime() const { return 0; }
+    double realTime() const { return 0; }
+  };
+      
+  ///Tool to measure the running time more exactly.
+  
+  ///This function calls \c f several times and returns the average
+  ///running time. The number of the executions will be choosen in such a way
+  ///that the full real running time will be roughly between \c min_time
+  ///and <tt>2*min_time</tt>.
+  ///\param f the function object to be measured.
+  ///\param min_time the minimum total running time.
+  ///\retval num if it is not \c NULL, then the actual
+  ///        number of execution of \c f will be written into <tt>*num</tt>.
+  ///\retval full_time if it is not \c NULL, then the actual
+  ///        total running time will be written into <tt>*full_time</tt>.
+  ///\return The average running time of \c f.
+  
+  template<class F>
+  TimeStamp runningTimeTest(F f,double min_time=10,unsigned int *num = NULL,
+                            TimeStamp *full_time=NULL)
+  {
+    TimeStamp full;
+    unsigned int total=0;
+    Timer t;
+    for(unsigned int tn=1;tn <= 1U<<31 && full.realTime()<=min_time; tn*=2) {
+      for(;total<tn;total++) f();
+      full=t;
+    }
+    if(num) *num=total;
+    if(full_time) *full_time=full;
+    return full/total;
+  }
+  
+  /// @}  
+
+
+} //namespace lemon
+
+#endif //LEMON_TIME_MEASURE_H
